require_relative 'util.rb'

require 'fileutils'

class Repository

	def initialize(path)
		@basePath = path

		# create repository base directory
		createDirectory(@basePath)

		# create sub-directories
		subPaths = ['ingest', 'archive', 'output']
		subPaths.each { |p|
			createDirectory(File.join(@basePath, p))
		}
	end

	def searchIngest
		# create our ingest directory path
		ingestPath = File.join(@basePath, 'ingest')
		# search for files in ingest; ignore non-files (e.g. directories)
		ingestFiles = Dir.entries(ingestPath).select { |f| File.file? File.join(ingestPath, f) }

		return ingestFiles
	end

	def archiveFile(filename)
		# create source and destination paths for the copy
		ingestPath = File.join(@basePath, 'ingest', filename)
		archivePath = File.join(@basePath, 'archive', filename)

		# perform the copy, preserving file attributes
		FileUtils.cp(ingestPath, archivePath, preserve: true)
	end

	def cleanupFile(filename)
		# create ingest path
		ingestPath = File.join(@basePath, 'ingest', filename)
		# remove the file
		FileUtils.remove_file(ingestPath)
	end

end
